/*
 * Copyright 2008 Niclas Hedhman.
 *
 * Licensed  under the  Apache License,  Version 2.0  (the "License");
 * you may not use  this file  except in  compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed  under the  License is distributed on an "AS IS" BASIS,
 * WITHOUT  WARRANTIES OR CONDITIONS  OF ANY KIND, either  express  or
 * implied.
 *
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package org.qi4j.logging.log.records;

import java.io.Serializable;
import java.util.List;
import org.qi4j.api.property.Property;
import org.qi4j.logging.log.LogType;

public interface LogRecord
{
    Property<String> message();

    Property<String> category();

    Property<String> compositeTypeName();

    Property<String> threadName();

    Property<LogType> logtype();

    Property<Long> time();

    Property<List<Serializable>> parameters();
}
